indexing
	description: "Routines for specialized numeric processing"
	license: "Eiffel Forumn License v2 - See license.txt"
	source: "{
		Amalasoft Corporation
		273 Harwood Avenue
		Littleton, MA 01460 USA
		}"
	status: "Copyright 1995-2009, Amalasoft"
	date: "$Date: 2009/02/28 $"
	revision: "$Revision: 001$"
	howto: "{
    Instantiate using default_create, or inherit
	 }"

class AEL_NUMERIC_ROUTINES

inherit
	AEL_NUMERIC_INTEGER_ROUTINES

create
	default_create

--|========================================================================
feature -- Conversion
--|========================================================================

	real_rounded_to_next_even_mod (v: REAL; m: INTEGER; zero_ok: BOOLEAN): INTEGER is
			-- The given number 'v', rounded toward higher magnitude,
			-- to an even multiple of 'm'
			-- Positive numbers are rounded up
			-- Negative numbers are rounded down
			-- If zero is acceptable (the 'zero_ok' flag = True) then
			-- a value of zero will yield a result of zero.  If not,
			-- then a value of zero will yield a result of 'm'
		require
			valid_mod: m > 1
		local
			tv: INTEGER
		do
			inspect v.sign
			when 1 then
				tv := v.ceiling
			when -1 then
				tv := v.floor
			else
			end
			Result := rounded_to_next_even_mod (tv, m, zero_ok)
		end

end -- class AEL_NUMERIC_ROUTINES
